# define the order of execution
stages:
    - preparation
    - build
    - test

variables:
    foo: bar

include:
    - local: '/proxy_settings.yml'
    #- local: '/before_script.yml'

before_script:
    - git clone --depth 1 https://gitlab.com/meleu.dev/pipelinefiles.git
    - cp pipelinefiles/hello.sh .

# list of jobs
hello world:
    stage: preparation
    script:
        - bash hello.sh

prepare the car:
    rules:
        - if: $foo != "bar"
          when: never
    # defining which stage this job belongs to
    stage: preparation
    script:
        - mkdir build
        - touch build/car.txt
    # artifacts are kept for the next job
    artifacts:
        paths:
            - build/

author:
    stage: build
    script:
        - mkdir meta
        - echo "$GITLAB_USER_NAME" > meta/author
    artifacts:
        paths:
            - meta/


build the car:
    # multiple jobs with the same stage run in parallel
    stage: build
    script:
        - cd build
        - echo "chassis" > car.txt
        - echo "engine" >> car.txt
        - echo "wheels" >> car.txt
    artifacts:
        paths:
            - build/

test the car:
    stage: test
    script:
        - ls
        - test -f build/car.txt
        - cd build
        - cat car.txt
        - grep "chassis" car.txt
        - grep "engine" car.txt
        - grep "wheels" car.txt
        - cat ../meta/author

